'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.docCommentIndex = docCommentIndex;
exports.hasDocComment = hasDocComment;
exports.getDocComment = getDocComment;
exports.getDoclet = getDoclet;

var _doctrine = require('doctrine');

var _doctrine2 = _interopRequireDefault(_doctrine);

function docCommentIndex(node) {
    if (!node.leadingComments) return -1;
    return Array.prototype.findIndex.call(node.leadingComments, function (comment) {
        return /^\*(?:$|[^*])/.test(comment.value);
    });
}

function hasDocComment(node) {
    return docCommentIndex(node) !== -1;
}

function getDocComment(node) {
    var idx = docCommentIndex(node);
    return idx === -1 ? undefined : node.leadingComments[idx].value;
}

function getDoclet(node) {
    var comment = getDocComment(node);
    if (!comment) return null;
    return _doctrine2['default'].parse(comment || '', {
        unwrap: true,
        loose: true
    });
}