'use strict';

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.appendDocFragment = appendDocFragment;
exports.addTag = addTag;

var _NodeUtils = require('./NodeUtils');

var _TagUtils = require('./TagUtils');

function appendDocFragment(fragment) {
    var idx = (0, _NodeUtils.docCommentIndex)(this.node);
    if (idx === -1) {
        this.addComment('leading', '* ' + fragment + ' ');
    } else {
        this.node.leadingComments[idx].value += '\n' + '* ' + fragment + ' ';
    }
}

function addTag(tagKeyProps, tagOtherProps) {
    if (typeof tagKeyProps === 'string') {
        tagKeyProps = {
            title: tagKeyProps
        };
    }

    tagOtherProps = tagOtherProps || {};
    var tag = tagKeyProps;
    var normTag = (0, _TagUtils.normalize)(tag);

    var doclet = (0, _NodeUtils.getDoclet)(this.node);

    var notexists = !doclet || !doclet.tags.map(_TagUtils.normalize).some(function (existingTag) {
        return _Object$keys(tagKeyProps).every(function (prop) {
            return existingTag[prop] === tag[prop];
        });
    });

    if (notexists) {
        tag = _Object$assign(tag, tagOtherProps);
        var elements = ['@' + tag.title, tag.type && '{' + tag.type + '}', tag.name, tag.name && tag.description && '-', tag.description].filter(Boolean);
        appendDocFragment.call(this, elements.join(' '));
    }
}